<app-loading *ngIf='isLoading'></app-loading>
<div class='content'>
  <mb-button *ngIf='objFunction?.view && tabSelectIndex !== 1' mbButtonType='NO_BORDER' (click)='goToAssignTargetToAllEmployee()'
             mbButtonSize='LARGE'
             mbButtonText="{{ 'goaManagement.assign-target-to-all-employees.label.table.assignToAll' | translate }}"
             mbButtonAvailableStyle='PRIMARY'>
  </mb-button>
  <mb-button *ngIf='objFunction?.edit && tabSelectIndex !== 1' mbButtonType='NO_BORDER' (click)='save()'
             mbButtonSize='LARGE'
             mbButtonText="{{ 'common.button.saveS' | translate}}"
             mbButtonAvailableStyle='PRIMARY'>
  </mb-button>
</div>
<div class="mb-tab">
  <nz-tabset nzType='editable-card' nzHideAdd (nzSelectChange)='changeTab($event)'
             [nzSelectedIndex]='tabSelectIndex'>
    <nz-tab nzTitle='Giao và duyệt'>
      <form-search-employee-component [isJanuary]="true" (getListSearchDataEmployee)='receiveDataEmployee($event)'>
      </form-search-employee-component>

      <form nz-form [formGroup]='formEmployee'>
        <div oncontextmenu='return false;' [formArrayName]='listEmplployee' class='data-table-plan-assignment'>
          <nz-table #basicTable [nzData]='listDataEmployee' class="data-table" [nzScroll]="{ x: '1000px', y: '35rem' }" nzSize='small'
                    [nzShowPagination]='false' nzTableLayout='fixed'>
            <thead>
            <tr>
              <th id='index' class='text-nowrap text-center' nzLeft nzWidth='4rem'>{{'targerManager.table.stt' | translate}}</th>
              <th id='codeEmploy' class='text-nowrap' nzWidth='8rem'>{{'targerManager.employTargetList.label.codeEmploy' | translate}}
              </th>
              <th id='fullname' class='text-nowrap'>{{'targerManager.employTargetList.label.fullname' | translate}}</th>
              <th id='setOfIndicatorsName' class='text-nowrap'>
                {{'targerManager.setOfIndicators.label.table.setOfIndicatorsName' | translate}}</th>
              <th id='position' class='text-nowrap'>{{'targerManager.setOfIndicators.label.table.position' | translate}}
              </th>
              <th id='asmFromDate' class='text-nowrap'>{{'targerManager.setOfIndicators.label.table.asmFromDate' | translate}}
              </th>
              <th id='asmToDate' class='text-nowrap'>{{'targerManager.setOfIndicators.label.table.asmToDate' | translate}}
              </th>
              <th id='flagStatus' class='text-nowrap' nzWidth='15rem'>{{'targerManager.setOfIndicators.label.table.flagStatus' |
                translate}}
              </th>
              <th id='density' class='text-nowrap' nzWidth='10rem'>{{'targerManager.employTargetList.label.density' | translate}}</th>
              <th id='operation' class='text-nowrap align-items-center' nzRight></th>
            </tr>
            </thead>
            <tbody *ngIf='listDataEmployee.length > 0'>
            <tr [ngClass]="{'hightlight-text ': employee.value?.isRejected && (employee.value?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_GIAO)}"
                *ngFor="let employee of formEmployee.get(listEmplployee)['controls']; let i = index; trackBy: trackByFnEmployee"
                [formGroupName]='i' (dblclick)='redirectToDetail(employee)'>
              <td nzLeft class="text-center">{{employee.value?.index + 1}}</td>
              <td>{{employee.value?.empCode}}</td>
              <td>{{employee.value?.fullName}}</td>
              <td>{{employee.value?.sotName}}</td>
              <td>{{employee.value?.posName}}</td>
              <td>{{employee.value?.asmFromDate | date: 'dd/MM/yyyy'}}</td>
              <td>{{employee.value?.asmToDate | date: 'dd/MM/yyyy'}}</td>
              <td>
                <nz-tag [nzColor]="'blue'"
                        *ngIf='employee.value?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_GIAO'>
                  {{'targerManager.common.notification.tranctionHasnotbeenSent' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'" *ngIf='employee.value?.flagStatus === processFlagStatus.CHO_XAC_NHAN_GIAO'>
                  {{'targerManager.common.notification.waitingForDeliveryConfirmation' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'" *ngIf='employee.value?.flagStatus === processFlagStatus.CHO_PHE_DUYET_GIAO'>
                  {{'targerManager.common.notification.waitingForDeliveryApproval' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'"
                        *ngIf='employee.value?.flagStatus === processFlagStatus.HOAN_TAT_PHE_DUYET_GIAO'>
                  {{'targerManager.common.notification.completeTheDeliveryApproval' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'"
                        *ngIf='employee.value?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_KQ'>
                  {{'targerManager.common.notification.haventSentConfirmationOfKQ' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'" *ngIf='employee.value?.flagStatus === processFlagStatus.CHO_XAC_NHAN_KQ'>
                  {{'targerManager.common.notification.waitingForConfirmationOfKQ' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'" *ngIf='employee.value?.flagStatus === processFlagStatus.CHO_PHE_DUYET_KQ'>
                  {{'targerManager.common.notification.waitingForResultsApproval' | translate}}</nz-tag>
                <nz-tag [nzColor]="'blue'"
                        *ngIf='employee.value?.flagStatus === processFlagStatus.HOAN_TAT_PHE_DUYET_KQ'>
                  {{'targerManager.common.notification.finalizationOfResultsApproval' | translate}}</nz-tag>
              </td>

              <td>
                <mb-input-text (click)='$event.stopPropagation()' [mbDisable]='employee.value?.isActive !== 1'
                               [formControlName]='currentScaleNum'
                               [mbType]="isSubmitted && (employee.controls[currentScaleNum].errors || employee.errors?.isNotDecimal || employee.errors?.scaleNumberTotalNotValid ) ? 'error' : 'default'"
                               [mbShowError]='isSubmitted && (employee.controls[currentScaleNum].errors || employee.errors?.isNotDecimal || employee.errors?.scaleNumberTotalNotValid) !== null'
                               [mbErrors]='(employee.errors?.isNotDecimal || employee.errors?.scaleNumberTotalNotValid) ? employee.errors : employee.controls[currentScaleNum].errors'
                               [mbErrorDefs]="[
                        { errorName: 'required', errorDescription: 'targerManager.validate.required' | translate: {'param': 'targerManager.employTargetList.label.density' | translate }},
                        { errorName: 'max', errorDescription: 'targerManager.validate.maxOne' | translate: {'param': 'targerManager.employTargetList.label.density' | translate }},
                        { errorName: 'min', errorDescription: 'targerManager.validate.maxOne' | translate: {'param': 'targerManager.employTargetList.label.density' | translate }},
                        { errorName: 'isNotDecimal', errorDescription: 'targerManager.validate.isNotDecimal' | translate: {'param': 'targerManager.employTargetList.label.density' | translate }},

                      ]" mbPlaceholderText="{{'targerManager.employTargetList.label.density' | translate}}"
                               [mbShowFlexEnd]="false">
                </mb-input-text>
              </td>
              <td [class.action-plan.action-plan]='employee.value?.flagStatus === processFlagStatus.CHO_PHE_DUYET_GIAO'
                  class='pt-2em text-center' nzRight>
                <mb-button mbButtonType='BORDER'
                           *ngIf='employee.value?.flagStatus === processFlagStatus.HOAN_TAT_PHE_DUYET_GIAO && employee.value?.managerId === currentUser?.empCode && objFunction?.edit'
                           mbButtonSize='SMALL' (click)='correctionShowModal(employee.value, $event)'
                           mbButtonAvailableStyle='PRIMARY'
                           mbButtonText="{{'targerManager.employTargetList.label.correction' | translate}}">
                </mb-button>
                <mb-button mbButtonType='BORDER'
                           *ngIf='employee.value?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_GIAO
                         && objFunction?.edit
                         && employee.value?.managerId === currentUser?.empCode'
                           [mbIsDisable]='isSaved && employee.value?.currentScaleNum === null' mbButtonSize='SMALL'
                           (click)='confirmApprove(employee.value?.currentScaleNum, employee.value?.asmIds, $event)'
                           mbButtonAvailableStyle='PRIMARY'
                           mbButtonText="{{'targerManager.employTargetList.label.sendEmployee' | translate}}">
                </mb-button>
                <span *ngIf='employee.value?.flagStatus === processFlagStatus.CHO_PHE_DUYET_GIAO
                && objFunction?.approve && !employee.value?.logic'>
                  <mb-button mbButtonType='NO_BORDER' mbButtonSize='LARGE'
                             (click)='approvePlanAssignment(employee.value, $event)'
                             mbButtonText="{{'targerManager.table.action.yes' | translate}}"
                             mbButtonAvailableStyle='PRIMARY'>
                  </mb-button>
                  <mb-button mbButtonType='NO_BORDER' mbButtonSize='LARGE'
                             (click)='showModalRejectPlan(employee.value, $event)'
                             mbButtonText="{{'targerManager.table.action.no' | translate}}"
                             mbButtonAvailableStyle='PRIMARY'>
                  </mb-button>
                </span>
              </td>
            </tr>
            </tbody>
          </nz-table>
        </div>
      </form>
      <mb-modal-confirm #modalCompReject
                        [modalHeader]="'Từ chối giá trị giao kế hoạch'"
                        [isVisibleCorrectionDialog]='false'
                        (sendApprovedValid)='rejectPlanAssignment($event)'
                        titleInputText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                        mbPlaceholderText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                        [mbErrorDefs]="[
                            { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
                            { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate:
                            {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }},
                            { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate:
                            {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }}]"

      >
      </mb-modal-confirm>

      <mb-modal-confirm #modalCompCorrection
                        [modalHeader]="'Hiệu chỉnh giá trị giao kế hoạch'"
                        [isVisibleCorrectionDialog]='false'
                        (sendApprovedValid)='correctionEmployTargetItem($event)'
                        titleInputText="{{'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate}}"
                        mbPlaceholderText="{{'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate}}"
                        [mbErrorDefs]="[
                      { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
                      { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate:
                      {'param': 'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate }},
                      { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate:
                      {'param': 'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate }}]"
      >
      </mb-modal-confirm>

    </nz-tab>
    <nz-tab nzTitle='Gán bộ chỉ tiêu' *ngIf="isDisplay">
      <app-set-targets-for-employees (changeTab)="changeTab($event)"></app-set-targets-for-employees>
    </nz-tab>
  </nz-tabset>
</div>

